package cn.com.qmth.export;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.lang3.StringUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.nodes.Node;

public class Answer {
	private Long id;
	private String body;
	private Double score;

	public String getBody() {
		return body;
	}

	public void setBody(String body) {
		this.body = body;
	}

	public Double getScore() {
		return score;
	}

	public void setScore(Double score) {
		this.score = score;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public static void main(String[] args) {
		String s="重力为P的圆球##1##放在板AC与##2##墙壁AB之间，如图所示。设板AC的重力不计，试作出球的受力图。<br/><img src=\"https://file.mshiedu.com/wisdomquestion/2023-5-16/mXQHiuaKLsYT6azLRSfj6praZ4EdPX2DsMHERvmkpA4YIoRY2a.jpeg\"/>发的发的发的<>";
		System.out.println(relaceQuestionIdx(s));
	}
	
    public static String relaceQuestionIdx(String str) {
        StringBuffer sb = new StringBuffer("");
        Pattern pattern = Pattern.compile("##(\\d+)##");

        Matcher matcher = pattern.matcher(str);

        while (matcher.find()) {
            String idx = matcher.group(1);
            matcher.appendReplacement(sb, "___" + idx + "___");
        }

        if (StringUtils.isEmpty(sb.toString())) {
            return str;
        } else {
            matcher.appendTail(sb);
            return sb.toString();
        }
    }

	private static String disBody(String html) {
		Document doc = Jsoup.parse(html);
		Element b = doc.body();
		if (b.childrenSize()== 1&&"p".equals(b.child(0).nodeName())) {
			b.child(0).tagName("span");
			b.child(0).removeAttr("style");
		}
		if (b.childrenSize()> 0) {
			for (Element n : b.children()) {
				if("p".equals(n.nodeName())) {
					boolean[] find=new boolean[] {false};
					findImg(n, find);
					if(!find[0]&&StringUtils.isBlank(n.text())) {
						n.tagName("span");
					}
				}
				disNode(n);
			}
		}
		return b.html();
	}
	
	private static void findImg(Element e,boolean[] find) {
		if(find[0]) {
			return;
		}else {
			if("img".equals(e.nodeName())) {
				find[0]=true;
				return;
			}else {
				if(e.childrenSize()>0) {
					for(Element ce:e.children()) {
						findImg(ce, find);
					}
				}else {
					return;
				}
			}
		}
	}
	private static void disNode(Node n) {
		if (n instanceof Element) {
			if (!"img".equals(n.nodeName())) {
				n.removeAttr("style");
			}
			if ("h1".equals(n.nodeName()) || "h2".equals(n.nodeName()) || "h3".equals(n.nodeName())
					|| "h4".equals(n.nodeName()) || "h5".equals(n.nodeName())) {
				((Element) n).tagName("h6");
			}
			if ("strong".equals(n.nodeName())||"a".equals(n.nodeName())||"u".equals(n.nodeName())||"em".equals(n.nodeName())) {
				((Element) n).tagName("span");
			}
			if (n.childNodeSize() > 0) {
				for (Node cn : n.childNodes()) {
					disNode(cn);
				}
			}
		}
	}

}
